<?php
/*
Plugin Name: Inline Multiple Uploading
Plugin URI: http://wordpress.ex-libris.jp/200604/inline-multiple-uploading/
Description: Replacement of WP's built-in uploading feature. This arrows multiple file uploading and image resize.
Author: Yoshi
Version: 0.3
Author URI: http://wordpress.ex-libris.jp
*/

add_filter('uploading_iframe_src', 'multipleuploading_iframe_src');


function multipleuploading_iframe_src($uploading_iframe_src) {
	$uploading_iframe_src = str_replace("inline-uploading.php","../wp-content/plugins/inline-multiple-uploading/inline-uploading.php",$uploading_iframe_src);
	return $uploading_iframe_src;
}



//code taken from function wp_create_thumbnail($file, $max_side, $effect = '')
function r_resize_image($file, $max_width = 500, $effect = '', $thumb_extention = '') {
	// 1 = GIF, 2 = JPEG, 3 = PNG

	if (file_exists($file)) {
		$type = getimagesize($file);

		// if the associated function doesn't exist - then it's not
		// handle. duh. i hope.

		if (!function_exists('imagegif') && $type[2] == 1) {
			$error = __('Filetype not supported. Thumbnail not created.');
		}
		elseif (!function_exists('imagejpeg') && $type[2] == 2) {
			$error = __('Filetype not supported. Thumbnail not created.');
		}
		elseif (!function_exists('imagepng') && $type[2] == 3) {
			$error = __('Filetype not supported. Thumbnail not created.');
		} else {

			// create the initial copy from the original file
			if ($type[2] == 1) {
				$image = imagecreatefromgif($file);
			}
			elseif ($type[2] == 2) {
				$image = imagecreatefromjpeg($file);
			}
			elseif ($type[2] == 3) {
				$image = imagecreatefrompng($file);
			}

			if (function_exists('imageantialias'))
				imageantialias($image, TRUE);

			$image_attr = getimagesize($file);
			$image_width = $image_attr[0];
			$image_height = $image_attr[1];

			// if width is smaller than the new size, no need for resizing
			if ($image_width <= $max_width) {
				$image_new_width = $image_width;
				$image_new_height = $image_height;
			}
			// do resize
			else {
				$image_new_width = $max_width;
				$image_ratio = $image_width / $image_new_width;
				$image_new_height = $image_height / $image_ratio;
			}

			$thumbnail = imagecreatetruecolor($image_new_width, $image_new_height);
			@ imagecopyresampled($thumbnail, $image, 0, 0, 0, 0, $image_new_width, $image_new_height, $image_attr[0], $image_attr[1]);

			if ('' == $thumb_extention)
				$thumb = basename($file);
			else 
				$thumb = preg_replace('!(\.[^.]+)?$!', $thumb_extention.'$1', basename($file), 1);
			
			$thumbpath = str_replace(basename($file), $thumb, $file);

			// move the thumbnail to it's final destination
			if ($type[2] == 1) {
				if (!imagegif($thumbnail, $thumbpath)) {
					$error = __("Thumbnail path invalid");
				}
			}
			elseif ($type[2] == 2) {
				if (!imagejpeg($thumbnail, $thumbpath, 95)) {
					$error = __("Thumbnail path invalid");
				}
			}
			elseif ($type[2] == 3) {
				if (!imagepng($thumbnail, $thumbpath)) {
					$error = __("Thumbnail path invalid");
				}
			}

		}
	} else {
		$error = __('File not found');
	}

	if (!empty ($error)) {
		return $error;
	} else {
		return $thumbpath;
	}
}

?>